/**********************************************
* PIC24HJ12GP202 t@~ 
*  OtBbNLCDeXgvO2
**********************************************/
#include <p24HJ12GP202.h>
#include "glcd_lib.h"
#include <math.h>
#include "imagedata.h"

/// RtBM[V rbg̐ݒ@ONbN 8MHz
_FBS(BSS_NO_FLASH & BWRP_WRPROTECT_OFF )
_FGS(GSS_OFF & GCP_OFF & GWRP_OFF )
_FOSCSEL(FNOSC_PRIPLL & IESO_ON)
_FOSC(FCKSM_CSECME & IOL1WAY_OFF & POSCMD_XT )
_FWDT(FWDTEN_OFF & WINDIS_OFF)
_FPOR(FPWRT_PWR32 & ALTI2C_OFF)


/* constant for 2D graphics */
#define X0	3
#define Y0	3
#define PI	3.141592654f
#define NODES	20
#define SIDE	6

/* Prototyping  */
void D2Graph(int Hight);


/************************************************
* C֐
*   OtBbNt\̊e\eXg
************************************************/
int main(void)
{
	AD1PCFGL = 0xFFF8;			// AN0-2 are Analog
	LATB = 0xFF7F;				// only LCD_E is low 
	TRISA = 0x000F;				// RA4̂ݏo
	TRISB = 0x000F;				// |[g̓o̓[hݒ
	CNPU1 = 0x00E0;				// RB1,2,3 pull up
	CNPU2 = 0x0080;				// CN23̃|[g̃vAbv
	CLKDIVbits.PLLPRE = 0;		// PLLPRE=1/2 to 4MHz
	PLLFBDbits.PLLDIV = 40;		// PLLDIV=1/40 to 200MHz
	CLKDIVbits.PLLPOST = 0;		// PLLPOST=1/2 to 80MHz then 40MIPS

	lcd_Init();										// GLCD
	/// C [v
 	while(1){
		int i, j, SW, index;
		
		/* Input Switch */
		SW = (~PORTB & 0x000E) >> 1;				// 10iXCb`̓́iʂRrbĝ݁j
		/* XCb`̒lɂe֕ */
		switch(SW){
			case 0:  								// SʃNÃeXg 	
				Delay1m(1000);
				lcd_Clear(0);						// S̏
				Delay1m(1000);	
				lcd_Clear(0xFF);					// S̕\
				break;
			case 1:									/* sNZ\@\ */							
				lcd_Clear(0);						// SNA
				for(i=0; i<64; i++){				// ΂ߒ̕\
					lcd_Pixel(i,i,1);				// CS1
					lcd_Pixel(64+i, i,1);			// CS2	
				}
				Delay1m(3000);						// Rb҂
				lcd_Clear(0xFF);					// S
				for(i=0; i<64; i++){				// ΂ߒ\

					lcd_Pixel(64+i, i,0);	
				}
				Delay1m(3000);						// 3b҂
				break;
			case 2:									// \eXg				
				lcd_Clear(0);						// NA
				for(j=0; j<8; j++){					// ASCIIS\@16/s
					for(i=0; i<16; i++){
						index = j*16+i+0x20;		// 96ŌJԂ
						lcd_Char(j, i, index);		// \
					}
				}
				Delay1m(3000);						// 3b҂
				lcd_Clear(0);						// NA
				for(j=0; j<8; j++){					// ASCIIS\@18/s
					for(i=0; i<18; i++){
						index = j*18+i+0x50;
						lcd_Char1(j, i, index);		// \
					}
				}
				Delay1m(3000);						// 3b҂
				break;
			case 3:									// C[W̕\eXg
				lcd_Image(Header2);
				Delay1m(3000);
				lcd_Scroll(50);				
				lcd_Image(Header3);
				Delay1m(3000);
				lcd_Scroll(100);												
				break;
			case 4:									// ̕\eXg
				lcd_Clear(0);
				Delay1m(1000);				
				lcd_Str(0, 0, "Hello World!!");
				lcd_Str(2, 0, "Graphic LCD Test!");
				Delay1m(3000);
				break;
			case 5:									// `eXg
				lcd_Clear(0);
				Delay1m(1000);	
				i = 0;
				for(j=0; j<32; j+=2){				// {bNX\
					lcd_Line(j,j, 127-j, j);		// ɏȃ{bNX
					lcd_Line(j,j, j, 63 -j);
					lcd_Line(127-j,63-j, 127-j,j);
					lcd_Line(128-j,63-j, j,63-j);
					Delay1m(500);
				}
				break;
			case 6:									// `iȐj
				lcd_Clear(0);
				Delay1m(1000);
				if(i>10)
					i=0;				
				D2Graph(10*i++);
				Delay1m(1000);								
			default: break;
		}
    }
}

/*********************************************
*  2̃Ot`֐
*   z(x,y) = 1/(1+SQRT(x2+y2))*COS(SQRT(x2+y2))
*    (-3*PI< x,y < 3*PI͈̔)
*   z̍őlPOTŕύX
**********************************************/
void D2Graph(int Hight) {
	int i, j, px, py,x, y, z;
	float zf, xf, yf, sf;
	struct{
		int x;
		int y;
	} edge[NODES], prev;

	lcd_Line(X0, 3, X0, 63);						// z axis
	lcd_Line(X0-3, Y0, 123, Y0);					// x axis
	lcd_Line(X0-2, Y0-2, X0+60, Y0+60);				// y axis
	for(j=0; j<NODES; j++) {
		edge[j].x = X0 + j*SIDE/2;
		edge[j].y = Y0 + j*SIDE/2;
	}
	for(i=0; i<NODES; i++) {
		x = i *SIDE;
		xf = (6 * PI / 200) *(float)(x-100);
		prev.y = Y0;
		prev.x = X0 + x;
		for(j=0; j<NODES; j++) {
			y = j * SIDE;
			yf = (6 * PI /200) * (float)(y -100);
			sf = sqrt(xf * xf + yf * yf);
			zf = 1/(1+sf) * cos(sf);
			z = zf * Hight;
			px = X0 + x + y/2;
			py = Y0 + z + y/2;
			lcd_Pixel(px, py, 1);
			lcd_Line(px, py, prev.x, prev.y);
			lcd_Line(px, py, edge[j].x, edge[j].y);
			prev.x = px;
			prev.y = py;
			edge[j].x = px;
			edge[j].y = py;
		}
	}
}

